
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _al=R5
	.DEF _ar=R4
	.DEF _starr=R7

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_comp_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0xD:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0
_0x105:
	.DB  0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x04
	.DW  0x04
	.DW  _0x105*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 05.08.2011
;Author  : NeVaDa
;Company :
;Comments:
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;unsigned char al=0;
;unsigned char ar=0;
;unsigned char starr=0;
;unsigned long int tmheat; // 
;eeprom unsigned char elvy=0;
;eeprom unsigned int  elsy=0;
;eeprom unsigned char elvx=0;
;eeprom unsigned int  elsx=0;
;eeprom unsigned char ervy=0;
;eeprom unsigned int  ersy=0;
;eeprom unsigned char ervx=0;
;eeprom unsigned int  ersx=0;
;eeprom unsigned char pause=0; //   . 
;
;#define ADC_VREF_TYPE 0xE0
;
;// Read the 8 most significant bits
;// of the AD conversion result
;unsigned char read_adc(unsigned char adc_input)
; 0000 002E {

	.CSEG
_read_adc:
; 0000 002F ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,LOW(0xE0)
	OUT  0x7,R30
; 0000 0030 // Delay needed for the stabilization of the ADC input voltage
; 0000 0031 delay_us(10);
	RCALL SUBOPT_0x0
; 0000 0032 // Start the AD conversion
; 0000 0033 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0034 // Wait for the AD conversion to complete
; 0000 0035 while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
; 0000 0036 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0037 return ADCH;
	IN   R30,0x5
	ADIW R28,1
	RET
; 0000 0038 }
;
;
;
;
;
;// Timer2 output compare interrupt service routine
;interrupt [TIM2_COMP] void timer2_comp_isr(void)
; 0000 0040 {
_timer2_comp_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0041 // Place your code here
; 0000 0042   if (starr==0)
	TST  R7
	BREQ _0x7
; 0000 0043            {
; 0000 0044             goto exi;
; 0000 0045            }
; 0000 0046    if (starr==2)
	RCALL SUBOPT_0x1
	BRNE _0x8
; 0000 0047    {
; 0000 0048     starr--;
	DEC  R7
; 0000 0049     read_adc(7); //L
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x2
; 0000 004A     al=ADCH;
	IN   R5,5
; 0000 004B     read_adc(6); //R
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x2
; 0000 004C     ar=ADCH;
	IN   R4,5
; 0000 004D     goto exi;
	RJMP _0x7
; 0000 004E    }
; 0000 004F    if (starr==1)
_0x8:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x9
; 0000 0050    {
; 0000 0051     starr=0;
	CLR  R7
; 0000 0052 
; 0000 0053    }
; 0000 0054 
; 0000 0055 
; 0000 0056  exi: if (tmheat>0)
_0x9:
_0x7:
	LDS  R26,_tmheat
	LDS  R27,_tmheat+1
	LDS  R24,_tmheat+2
	LDS  R25,_tmheat+3
	RCALL __CPD02
	BRSH _0xA
; 0000 0057         //   
; 0000 0058         {
; 0000 0059          tmheat--;
	LDI  R26,LOW(_tmheat)
	LDI  R27,HIGH(_tmheat)
	RCALL __GETD1P_INC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	RCALL __PUTDP1_DEC
; 0000 005A          goto exi2;
	RJMP _0xB
; 0000 005B         }
; 0000 005C         //        
; 0000 005D         if (PINC&1==1)
_0xA:
	SBIS 0x13,0
	RJMP _0xC
; 0000 005E         {
; 0000 005F           PORTC=32;
	LDI  R30,LOW(32)
	RJMP _0x103
; 0000 0060           goto exi2;
; 0000 0061 
; 0000 0062 
; 0000 0063         }
; 0000 0064 
; 0000 0065          PORTC=0;
_0xC:
	LDI  R30,LOW(0)
_0x103:
	OUT  0x15,R30
; 0000 0066  exi2: #asm("nop");
_0xB:
	nop
; 0000 0067 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;
;
;// Declare your global variables here
;
;void main(void)
; 0000 006F {
_main:
; 0000 0070 // Declare your local variables here
; 0000 0071       unsigned char lvy; //   Y
; 0000 0072       unsigned int  lsy; //    Y
; 0000 0073 
; 0000 0074 
; 0000 0075 
; 0000 0076    //----------------------------
; 0000 0077 
; 0000 0078       unsigned char lvx; //   X
; 0000 0079       unsigned int lsx; //    X
; 0000 007A 
; 0000 007B 
; 0000 007C 
; 0000 007D    //----------------------------
; 0000 007E       unsigned char rvy; //   Y
; 0000 007F       unsigned int rsy; //    Y
; 0000 0080 
; 0000 0081 
; 0000 0082    //----------------------------
; 0000 0083 
; 0000 0084       unsigned char rvx; //   X
; 0000 0085       unsigned int rsx; //    X
; 0000 0086 
; 0000 0087 
; 0000 0088 
; 0000 0089     //----------------------------
; 0000 008A   unsigned char cancel=0;   //  
; 0000 008B 
; 0000 008C   unsigned int timer;
; 0000 008D 
; 0000 008E   unsigned char drive;
; 0000 008F   unsigned char port;
; 0000 0090 
; 0000 0091   unsigned char pro=0;
; 0000 0092   unsigned char base=0;
; 0000 0093 
; 0000 0094 
; 0000 0095   unsigned int stl;
; 0000 0096   unsigned int str;
; 0000 0097   unsigned char temp;  // 
; 0000 0098   unsigned int  templ; // 
; 0000 0099 
; 0000 009A 
; 0000 009B   unsigned char lv1=0;   //    1
; 0000 009C   unsigned char lv0=0;   //    0
; 0000 009D 
; 0000 009E   unsigned char rv1=0;   //    1
; 0000 009F   unsigned char rv0=0;   //    0
; 0000 00A0 
; 0000 00A1 
; 0000 00A2 
; 0000 00A3   unsigned char lal=0; //    L
; 0000 00A4   unsigned char lar=0;   //    R
; 0000 00A5 
; 0000 00A6   unsigned char gis=0; //   
; 0000 00A7 
; 0000 00A8 
; 0000 00A9 
; 0000 00AA 
; 0000 00AB // Input/Output Ports initialization
; 0000 00AC // Port B initialization
; 0000 00AD // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out
; 0000 00AE // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00AF PORTB=0x00;
	SBIW R28,27
	LDI  R24,21
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xD*2)
	LDI  R31,HIGH(_0xD*2)
	RCALL __INITLOCB
;	lvy -> R17
;	lsy -> R18,R19
;	lvx -> R16
;	lsx -> R20,R21
;	rvy -> Y+26
;	rsy -> Y+24
;	rvx -> Y+23
;	rsx -> Y+21
;	cancel -> Y+20
;	timer -> Y+18
;	drive -> Y+17
;	port -> Y+16
;	pro -> Y+15
;	base -> Y+14
;	stl -> Y+12
;	str -> Y+10
;	temp -> Y+9
;	templ -> Y+7
;	lv1 -> Y+6
;	lv0 -> Y+5
;	rv1 -> Y+4
;	rv0 -> Y+3
;	lal -> Y+2
;	lar -> Y+1
;	gis -> Y+0
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 00B0 DDRB=0x03;
	LDI  R30,LOW(3)
	OUT  0x17,R30
; 0000 00B1 
; 0000 00B2 // Port C initialization
; 0000 00B3 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00B4 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00B5 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 00B6 DDRC=0x20;
	LDI  R30,LOW(32)
	OUT  0x14,R30
; 0000 00B7 
; 0000 00B8 // Port D initialization
; 0000 00B9 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00BA // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 00BB PORTD=0x00;
	RCALL SUBOPT_0x3
; 0000 00BC DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 00BD 
; 0000 00BE 
; 0000 00BF 
; 0000 00C0 
; 0000 00C1 
; 0000 00C2 // Timer/Counter 0 initialization
; 0000 00C3 // Clock source: System Clock
; 0000 00C4 // Clock value: Timer 0 Stopped
; 0000 00C5 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 00C6 TCNT0=0x00;
	OUT  0x32,R30
; 0000 00C7 
; 0000 00C8 // Timer/Counter 1 initialization
; 0000 00C9 // Clock source: System Clock
; 0000 00CA // Clock value: Timer1 Stopped
; 0000 00CB // Mode: Normal top=FFFFh
; 0000 00CC // OC1A output: Discon.
; 0000 00CD // OC1B output: Discon.
; 0000 00CE // Noise Canceler: Off
; 0000 00CF // Input Capture on Falling Edge
; 0000 00D0 // Timer1 Overflow Interrupt: Off
; 0000 00D1 // Input Capture Interrupt: Off
; 0000 00D2 // Compare A Match Interrupt: Off
; 0000 00D3 // Compare B Match Interrupt: Off
; 0000 00D4 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00D5 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00D6 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00D7 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00D8 ICR1H=0x00;
	OUT  0x27,R30
; 0000 00D9 ICR1L=0x00;
	OUT  0x26,R30
; 0000 00DA OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00DB OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00DC OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00DD OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00DE 
; 0000 00DF 
; 0000 00E0 
; 0000 00E1 
; 0000 00E2 
; 0000 00E3 // Timer/Counter 2 initialization
; 0000 00E4 // Clock source: System Clock
; 0000 00E5 // Clock value: 1000,000 kHz
; 0000 00E6 // Mode: CTC top=OCR2
; 0000 00E7 // OC2 output: Disconnected
; 0000 00E8 ASSR=0x00;
	OUT  0x22,R30
; 0000 00E9 TCCR2=0x0A;
	LDI  R30,LOW(10)
	OUT  0x25,R30
; 0000 00EA TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 00EB OCR2=0xFA;
	LDI  R30,LOW(250)
	OUT  0x23,R30
; 0000 00EC 
; 0000 00ED 
; 0000 00EE // External Interrupt(s) initialization
; 0000 00EF // INT0: Off
; 0000 00F0 // INT1: Off
; 0000 00F1 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 00F2 
; 0000 00F3 
; 0000 00F4 
; 0000 00F5 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00F6 TIMSK=0x80;
	LDI  R30,LOW(128)
	OUT  0x39,R30
; 0000 00F7 
; 0000 00F8 // Analog Comparator initialization
; 0000 00F9 // Analog Comparator: Off
; 0000 00FA // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00FB ACSR=0x80;
	OUT  0x8,R30
; 0000 00FC SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00FD 
; 0000 00FE // ADC initialization
; 0000 00FF // ADC Clock frequency: 1000,000 kHz
; 0000 0100 // ADC Voltage Reference: Int., cap. on AREF
; 0000 0101 // Only the 8 most significant bits of
; 0000 0102 // the AD conversion result are used
; 0000 0103 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(224)
	OUT  0x7,R30
; 0000 0104 ADCSRA=0x83;
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 0105 
; 0000 0106 // Global disable interrupts
; 0000 0107 #asm("cli")
	cli
; 0000 0108 
; 0000 0109 
; 0000 010A 
; 0000 010B       while (1)
; 0000 010C       {
; 0000 010D       // Place your code here
; 0000 010E          delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x4
; 0000 010F        /*
; 0000 0110            1.  
; 0000 0111            2. 
; 0000 0112            3.   
; 0000 0113                   -    
; 0000 0114                   -    
; 0000 0115                   -     
; 0000 0116            4.    
; 0000 0117         */
; 0000 0118 
; 0000 0119 
; 0000 011A 
; 0000 011B                     PORTB=1;
	RCALL SUBOPT_0x5
; 0000 011C                 delay_us(10);
; 0000 011D                 temp=PINB;
; 0000 011E 
; 0000 011F 
; 0000 0120     if (temp==145)                    //128+1+16
	LDD  R26,Y+9
	CPI  R26,LOW(0x91)
	BRNE _0x11
; 0000 0121                 {
; 0000 0122                     PORTB=2;
	RCALL SUBOPT_0x6
; 0000 0123                     delay_us(10);
; 0000 0124                     temp=PINB;
; 0000 0125                  //      
; 0000 0126                     if (temp==134)    //128+2+4
	CPI  R26,LOW(0x86)
	BREQ _0x13
; 0000 0127                     // 
; 0000 0128                     {
; 0000 0129 
; 0000 012A                      goto clear;
; 0000 012B 
; 0000 012C                     }
; 0000 012D 
; 0000 012E                        if (temp==162)     //128+2+32
	LDD  R26,Y+9
	CPI  R26,LOW(0xA2)
	BREQ _0x13
; 0000 012F                     // 
; 0000 0130                     {
; 0000 0131 
; 0000 0132                       goto clear;
; 0000 0133 
; 0000 0134                     }
; 0000 0135                   //       
; 0000 0136                       if (temp==138)     //128+2+8
	CPI  R26,LOW(0x8A)
	BREQ _0x16
; 0000 0137                     // 
; 0000 0138                     {
; 0000 0139 
; 0000 013A                       goto pause0;
; 0000 013B 
; 0000 013C                     }
; 0000 013D                             if (temp==194)       //128+2+64
	CPI  R26,LOW(0xC2)
	BREQ _0x16
; 0000 013E                     //  
; 0000 013F                     {
; 0000 0140 
; 0000 0141                       goto pause0;
; 0000 0142 
; 0000 0143                     }
; 0000 0144                 }
; 0000 0145 
; 0000 0146            //       
; 0000 0147 
; 0000 0148     if (temp==137||temp==193)                        //128+1+8        128+1+64
_0x11:
	LDD  R26,Y+9
	CPI  R26,LOW(0x89)
	BREQ _0x19
	CPI  R26,LOW(0xC1)
	BRNE _0x18
_0x19:
; 0000 0149                 {
; 0000 014A                     PORTB=2;
	RCALL SUBOPT_0x6
; 0000 014B                     delay_us(10);
; 0000 014C                     temp=PINB;
; 0000 014D 
; 0000 014E                     if (temp==146)         //128+2+16
	CPI  R26,LOW(0x92)
	BREQ _0x1C
; 0000 014F                     //      
; 0000 0150                     {
; 0000 0151 
; 0000 0152                       goto pause1;
; 0000 0153 
; 0000 0154                     }
; 0000 0155 
; 0000 0156 
; 0000 0157 
; 0000 0158                 }
; 0000 0159                 goto ini;
_0x18:
	RJMP _0x1D
; 0000 015A 
; 0000 015B     pause0:
_0x16:
; 0000 015C         //    
; 0000 015D 
; 0000 015E 
; 0000 015F         read_adc(4);
	RCALL SUBOPT_0x7
; 0000 0160         if (ADCH<83)
	RCALL SUBOPT_0x8
	BRSH _0x1E
; 0000 0161         {
; 0000 0162          gis=1;
	RCALL SUBOPT_0x9
; 0000 0163          goto ini;
	RJMP _0x1D
; 0000 0164         }
; 0000 0165 
; 0000 0166         pause=0;
_0x1E:
	LDI  R26,LOW(_pause)
	LDI  R27,HIGH(_pause)
	RCALL SUBOPT_0xA
; 0000 0167         goto ini2;
	RJMP _0x1F
; 0000 0168 
; 0000 0169     pause1:
_0x1C:
; 0000 016A        //    
; 0000 016B            read_adc(4);
	RCALL SUBOPT_0x7
; 0000 016C         if (ADCH<83)
	RCALL SUBOPT_0x8
	BRSH _0x20
; 0000 016D         {
; 0000 016E          gis=1;
	RCALL SUBOPT_0x9
; 0000 016F          goto ini;
	RJMP _0x1D
; 0000 0170         }
; 0000 0171         pause=1;
_0x20:
	LDI  R26,LOW(_pause)
	LDI  R27,HIGH(_pause)
	LDI  R30,LOW(1)
	RCALL __EEPROMWRB
; 0000 0172         goto ini2;
	RJMP _0x1F
; 0000 0173 
; 0000 0174     clear:
_0x13:
; 0000 0175         //  
; 0000 0176 
; 0000 0177         read_adc(4);
	RCALL SUBOPT_0x7
; 0000 0178         if (ADCH<83)
	RCALL SUBOPT_0x8
	BRSH _0x21
; 0000 0179         {
; 0000 017A          gis=1;
	RCALL SUBOPT_0x9
; 0000 017B          goto ini;
	RJMP _0x1D
; 0000 017C         }
; 0000 017D 
; 0000 017E       elvy=0;
_0x21:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xA
; 0000 017F       elsy=0;
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
; 0000 0180       elvx=0;
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xA
; 0000 0181       elsx=0;
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xD
; 0000 0182 
; 0000 0183       ervy=0;
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xA
; 0000 0184       ersy=0;
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xD
; 0000 0185       ervx=0;
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0xA
; 0000 0186       ersx=0;
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0xD
; 0000 0187 
; 0000 0188 ini2:  delay_ms(5000);
_0x1F:
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	RCALL SUBOPT_0x4
; 0000 0189 
; 0000 018A       // 
; 0000 018B ini:      #asm("cli");  //  
_0x1D:
	cli
; 0000 018C           delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x4
; 0000 018D 
; 0000 018E 
; 0000 018F 
; 0000 0190        tmheat=0;
	LDI  R30,LOW(0)
	STS  _tmheat,R30
	STS  _tmheat+1,R30
	STS  _tmheat+2,R30
	STS  _tmheat+3,R30
; 0000 0191        PORTB=0;
	OUT  0x18,R30
; 0000 0192        PORTC=0;
	OUT  0x15,R30
; 0000 0193        PORTD=0;
	RCALL SUBOPT_0x3
; 0000 0194 
; 0000 0195          // 
; 0000 0196 
; 0000 0197           read_adc(4);
	RCALL SUBOPT_0x7
; 0000 0198           temp=ADCH;
	IN   R30,0x5
	RCALL SUBOPT_0x14
; 0000 0199           if (temp<83)         //10,5v
	CPI  R26,LOW(0x53)
	BRLO _0x1D
; 0000 019A            {
; 0000 019B             goto ini;
; 0000 019C             gis=1;
; 0000 019D            }
; 0000 019E 
; 0000 019F 
; 0000 01A0             if (temp>94)       //11,5v  91
	LDD  R26,Y+9
	CPI  R26,LOW(0x5F)
	BRLO _0x23
; 0000 01A1             //  
; 0000 01A2            {
; 0000 01A3             gis=0;
	LDI  R30,LOW(0)
	ST   Y,R30
; 0000 01A4            }
; 0000 01A5 
; 0000 01A6            if (gis==1)
_0x23:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BREQ _0x1D
; 0000 01A7            {
; 0000 01A8             goto ini;
; 0000 01A9            }
; 0000 01AA 
; 0000 01AB 
; 0000 01AC       lvy=elvy;
	RCALL SUBOPT_0xB
	RCALL __EEPROMRDB
	MOV  R17,R30
; 0000 01AD       lsy=elsy;
	RCALL SUBOPT_0xC
	RCALL __EEPROMRDW
	MOVW R18,R30
; 0000 01AE       lvx=elvx;
	RCALL SUBOPT_0xE
	RCALL __EEPROMRDB
	MOV  R16,R30
; 0000 01AF       lsx=elsx;
	RCALL SUBOPT_0xF
	RCALL __EEPROMRDW
	MOVW R20,R30
; 0000 01B0 
; 0000 01B1       rvy=ervy;
	RCALL SUBOPT_0x10
	RCALL __EEPROMRDB
	STD  Y+26,R30
; 0000 01B2       rsy=ersy;
	RCALL SUBOPT_0x11
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x15
; 0000 01B3       rvx=ervx;
	RCALL SUBOPT_0x12
	RCALL __EEPROMRDB
	STD  Y+23,R30
; 0000 01B4       rsx=ersx;
	RCALL SUBOPT_0x13
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x16
; 0000 01B5 
; 0000 01B6 
; 0000 01B7 
; 0000 01B8       if (lsy>2000)
	__CPWRN 18,19,2001
	BRLO _0x25
; 0000 01B9        {
; 0000 01BA         lsy=0;
	__GETWRN 18,19,0
; 0000 01BB        }
; 0000 01BC       if (lsx>2000)
_0x25:
	__CPWRN 20,21,2001
	BRLO _0x26
; 0000 01BD        {
; 0000 01BE         lsx=0;
	__GETWRN 20,21,0
; 0000 01BF        }
; 0000 01C0       if (rsy>2000)
_0x26:
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	BRLO _0x27
; 0000 01C1        {
; 0000 01C2         rsy=0;
	LDI  R30,LOW(0)
	STD  Y+24,R30
	STD  Y+24+1,R30
; 0000 01C3        }
; 0000 01C4       if (rsx>2000)
_0x27:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x18
	BRLO _0x28
; 0000 01C5        {
; 0000 01C6         rsx=0;
	LDI  R30,LOW(0)
	STD  Y+21,R30
	STD  Y+21+1,R30
; 0000 01C7        }
; 0000 01C8 
; 0000 01C9       if (lvy!=96)
_0x28:
	CPI  R17,96
	BREQ _0x29
; 0000 01CA        {
; 0000 01CB         if(lvy!=80)
	CPI  R17,80
	BREQ _0x2A
; 0000 01CC          {
; 0000 01CD           lvy=0;
	LDI  R17,LOW(0)
; 0000 01CE          }
; 0000 01CF 
; 0000 01D0        }
_0x2A:
; 0000 01D1       if (lvx!=160)
_0x29:
	CPI  R16,160
	BREQ _0x2B
; 0000 01D2        {
; 0000 01D3         if(lvx!=144)
	CPI  R16,144
	BREQ _0x2C
; 0000 01D4          {
; 0000 01D5           lvx=0;
	LDI  R16,LOW(0)
; 0000 01D6          }
; 0000 01D7 
; 0000 01D8        }
_0x2C:
; 0000 01D9       if (rvy!=6)
_0x2B:
	LDD  R26,Y+26
	CPI  R26,LOW(0x6)
	BREQ _0x2D
; 0000 01DA        {
; 0000 01DB         if(rvy!=5)
	CPI  R26,LOW(0x5)
	BREQ _0x2E
; 0000 01DC          {
; 0000 01DD           rvy=0;
	LDI  R30,LOW(0)
	STD  Y+26,R30
; 0000 01DE          }
; 0000 01DF 
; 0000 01E0        }
_0x2E:
; 0000 01E1       if (rvx!=9)
_0x2D:
	LDD  R26,Y+23
	CPI  R26,LOW(0x9)
	BREQ _0x2F
; 0000 01E2        {
; 0000 01E3         if(rvx!=10)
	CPI  R26,LOW(0xA)
	BREQ _0x30
; 0000 01E4          {
; 0000 01E5           rvx=0;
	LDI  R30,LOW(0)
	STD  Y+23,R30
; 0000 01E6          }
; 0000 01E7 
; 0000 01E8        }
_0x30:
; 0000 01E9           base=10;
_0x2F:
	RCALL SUBOPT_0x1A
; 0000 01EA           #asm("sei");
	sei
; 0000 01EB 
; 0000 01EC main: switch (base)
_0x31:
	LDD  R30,Y+14
	LDI  R31,0
; 0000 01ED    {
; 0000 01EE 
; 0000 01EF      case 10:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x35
; 0000 01F0 
; 0000 01F1      {
; 0000 01F2         // 
; 0000 01F3         #asm("cli");
	cli
; 0000 01F4         read_adc(4);
	RCALL SUBOPT_0x7
; 0000 01F5         if (ADCH<83)
	RCALL SUBOPT_0x8
	BRSH _0x36
; 0000 01F6         {
; 0000 01F7          gis=1;
	RCALL SUBOPT_0x9
; 0000 01F8          goto ini;
	RJMP _0x1D
; 0000 01F9         }
; 0000 01FA 
; 0000 01FB         if (gis==1)
_0x36:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x37
; 0000 01FC         {
; 0000 01FD          goto ini;
	RJMP _0x1D
; 0000 01FE         }
; 0000 01FF 
; 0000 0200         #asm("sei");
_0x37:
	sei
; 0000 0201 
; 0000 0202         temp=PINB;
	RCALL SUBOPT_0x1B
; 0000 0203         temp=temp&128;
; 0000 0204         if (temp==0)
	BRNE _0x38
; 0000 0205         //  rear=0
; 0000 0206          {
; 0000 0207           cancel=0;
	LDI  R30,LOW(0)
	STD  Y+20,R30
; 0000 0208           base=20;  //  
	LDI  R30,LOW(20)
	STD  Y+14,R30
; 0000 0209           goto main;
	RJMP _0x31
; 0000 020A          }
; 0000 020B         if (cancel==1)
_0x38:
	LDD  R26,Y+20
	CPI  R26,LOW(0x1)
	BRNE _0x39
; 0000 020C          {
; 0000 020D           base=20;  //  
	LDI  R30,LOW(20)
	STD  Y+14,R30
; 0000 020E           goto main;
	RJMP _0x31
; 0000 020F          }
; 0000 0210 
; 0000 0211         timer=200;   //    
_0x39:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x1C
; 0000 0212         if (pause>0)
	LDI  R26,LOW(_pause)
	LDI  R27,HIGH(_pause)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x1)
	BRLO _0x3A
; 0000 0213 
; 0000 0214         {
; 0000 0215          timer=6000; //   1,5 .  
	LDI  R30,LOW(6000)
	LDI  R31,HIGH(6000)
	RCALL SUBOPT_0x1C
; 0000 0216         }
; 0000 0217 
; 0000 0218 wait2s:         starr=1;
_0x3A:
_0x3B:
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 0219 wait2:          if (starr==1)
_0x3C:
	LDI  R30,LOW(1)
	CP   R30,R7
	BREQ _0x3C
; 0000 021A                  {
; 0000 021B                   goto wait2;
; 0000 021C                  }
; 0000 021D        timer--;
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
; 0000 021E        if (timer!=0)
	BRNE _0x3B
; 0000 021F         {
; 0000 0220          goto wait2s;
; 0000 0221         }
; 0000 0222 
; 0000 0223         temp=PINB;
	RCALL SUBOPT_0x1B
; 0000 0224         temp=temp&128;
; 0000 0225         if (temp==0)
	BRNE _0x3F
; 0000 0226          {
; 0000 0227           base=20; //  
	LDI  R30,LOW(20)
	STD  Y+14,R30
; 0000 0228           goto main;
	RJMP _0x31
; 0000 0229          }
; 0000 022A 
; 0000 022B         base=1;  // rear
_0x3F:
	LDI  R30,LOW(1)
	STD  Y+14,R30
; 0000 022C         goto main;
	RJMP _0x31
; 0000 022D 
; 0000 022E      }
; 0000 022F 
; 0000 0230      case 20:
_0x35:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x41
; 0000 0231       //  
; 0000 0232      {
; 0000 0233 
; 0000 0234                  PORTB=1;
	RCALL SUBOPT_0x5
; 0000 0235                 delay_us(10);
; 0000 0236                 temp=PINB;
; 0000 0237                 temp=temp&127;
	RCALL SUBOPT_0x1F
; 0000 0238                 if (temp==5)           //1+4
	CPI  R26,LOW(0x5)
	BRNE _0x42
; 0000 0239                 {
; 0000 023A                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 023B                     delay_us(10);
; 0000 023C                     temp=PINB;
; 0000 023D                     temp=temp&127;
; 0000 023E                     if (temp==18)      //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x43
; 0000 023F                     // 
; 0000 0240                     {
; 0000 0241                       port=80;
	LDI  R30,LOW(80)
	RJMP _0x104
; 0000 0242                       goto scan0;
; 0000 0243 
; 0000 0244                     }
; 0000 0245 
; 0000 0246                      goto scanp;
_0x43:
	RJMP _0x45
; 0000 0247                 }
; 0000 0248 
; 0000 0249                 if (temp==17)            //1+16
_0x42:
	LDD  R26,Y+9
	CPI  R26,LOW(0x11)
	BRNE _0x46
; 0000 024A                 {
; 0000 024B                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 024C                     delay_us(10);
; 0000 024D                     temp=PINB;
; 0000 024E                      temp=temp&127;
; 0000 024F                     if (temp==6)        //2+4
	CPI  R26,LOW(0x6)
	BRNE _0x47
; 0000 0250                     // 
; 0000 0251                     {
; 0000 0252                       port=96;
	LDI  R30,LOW(96)
	RJMP _0x104
; 0000 0253                       goto scan0;
; 0000 0254 
; 0000 0255                     }
; 0000 0256 
; 0000 0257 
; 0000 0258                        if (temp==10)       //2+8
_0x47:
	LDD  R26,Y+9
	CPI  R26,LOW(0xA)
	BRNE _0x48
; 0000 0259                     // 
; 0000 025A                     {
; 0000 025B                       port=160;
	LDI  R30,LOW(160)
	RJMP _0x104
; 0000 025C                       goto scan0;
; 0000 025D 
; 0000 025E                     }
; 0000 025F                       if (temp==34)        //2+32
_0x48:
	LDD  R26,Y+9
	CPI  R26,LOW(0x22)
	BRNE _0x49
; 0000 0260                     // 
; 0000 0261                     {
; 0000 0262                       port=6;
	LDI  R30,LOW(6)
	RJMP _0x104
; 0000 0263                       goto scan0;
; 0000 0264 
; 0000 0265                     }
; 0000 0266 
; 0000 0267                        if (temp==66)       //2+64
_0x49:
	LDD  R26,Y+9
	CPI  R26,LOW(0x42)
	BRNE _0x4A
; 0000 0268                     //  
; 0000 0269                     {
; 0000 026A                       port=10;
	LDI  R30,LOW(10)
	RJMP _0x104
; 0000 026B                       goto scan0;
; 0000 026C 
; 0000 026D                     }
; 0000 026E                     goto scanp;
_0x4A:
	RJMP _0x45
; 0000 026F 
; 0000 0270 
; 0000 0271                 }
; 0000 0272 
; 0000 0273                  if (temp==9)            //1+8
_0x46:
	LDD  R26,Y+9
	CPI  R26,LOW(0x9)
	BRNE _0x4B
; 0000 0274                 {
; 0000 0275                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 0276                     delay_us(10);
; 0000 0277                     temp=PINB;
; 0000 0278                      temp=temp&127;
; 0000 0279                     if (temp==18)         //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x4C
; 0000 027A                     // 
; 0000 027B                     {
; 0000 027C                       port=144;
	LDI  R30,LOW(144)
	RJMP _0x104
; 0000 027D                       goto scan0;
; 0000 027E 
; 0000 027F                     }
; 0000 0280 
; 0000 0281 
; 0000 0282 
; 0000 0283                     goto scanp;
_0x4C:
	RJMP _0x45
; 0000 0284                 }
; 0000 0285 
; 0000 0286                  if (temp==33)
_0x4B:
	LDD  R26,Y+9
	CPI  R26,LOW(0x21)
	BRNE _0x4D
; 0000 0287                 {
; 0000 0288                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 0289                     delay_us(10);
; 0000 028A                     temp=PINB;
; 0000 028B                      temp=temp&127;
; 0000 028C                     if (temp==18)       //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x4E
; 0000 028D                     // 
; 0000 028E                     {
; 0000 028F                       port=5;
	LDI  R30,LOW(5)
	RJMP _0x104
; 0000 0290                       goto scan0;
; 0000 0291 
; 0000 0292                     }
; 0000 0293 
; 0000 0294 
; 0000 0295 
; 0000 0296                     goto scanp;
_0x4E:
	RJMP _0x45
; 0000 0297                 }
; 0000 0298                  if (temp==65)          //1+64
_0x4D:
	LDD  R26,Y+9
	CPI  R26,LOW(0x41)
	BRNE _0x4F
; 0000 0299                 {
; 0000 029A                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 029B                     delay_us(10);
; 0000 029C                     temp=PINB;
; 0000 029D                      temp=temp&127;
; 0000 029E 
; 0000 029F                        if (temp==18)    //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x50
; 0000 02A0                     //  
; 0000 02A1                     {
; 0000 02A2                       port=9;
	LDI  R30,LOW(9)
	RJMP _0x104
; 0000 02A3                       goto scan0;
; 0000 02A4 
; 0000 02A5                     }
; 0000 02A6 
; 0000 02A7                 }
_0x50:
; 0000 02A8 scanp:          port=0;
_0x4F:
_0x45:
	LDI  R30,LOW(0)
_0x104:
	STD  Y+16,R30
; 0000 02A9 
; 0000 02AA scan0:
; 0000 02AB        if (tmheat==0)
	LDS  R30,_tmheat
	LDS  R31,_tmheat+1
	LDS  R22,_tmheat+2
	LDS  R23,_tmheat+3
	RCALL __CPD10
	BRNE _0x51
; 0000 02AC        {
; 0000 02AD         if (port==5||port==80)
	LDD  R26,Y+16
	CPI  R26,LOW(0x5)
	BREQ _0x53
	CPI  R26,LOW(0x50)
	BRNE _0x52
_0x53:
; 0000 02AE         {
; 0000 02AF           timer=4000; //  1    
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x1C
; 0000 02B0 
; 0000 02B1 wait10s:   starr=1;
_0x55:
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 02B2 wait10:    if (starr==1)
_0x56:
	LDI  R30,LOW(1)
	CP   R30,R7
	BREQ _0x56
; 0000 02B3                  {
; 0000 02B4                   goto wait10;
; 0000 02B5                  }
; 0000 02B6           timer--;
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
; 0000 02B7           if (timer!=0)
	BRNE _0x55
; 0000 02B8            {
; 0000 02B9             goto wait10s;
; 0000 02BA            }
; 0000 02BB           tmheat=3600000;   //   15 
	__GETD1N 0x36EE80
	STS  _tmheat,R30
	STS  _tmheat+1,R31
	STS  _tmheat+2,R22
	STS  _tmheat+3,R23
; 0000 02BC            //tmheat=20000;
; 0000 02BD            PORTC=32;
	LDI  R30,LOW(32)
	OUT  0x15,R30
; 0000 02BE            base=10;
	RCALL SUBOPT_0x1A
; 0000 02BF            goto main;
	RJMP _0x31
; 0000 02C0         }
; 0000 02C1        }
_0x52:
; 0000 02C2 
; 0000 02C3        PORTD=port;
_0x51:
	RCALL SUBOPT_0x21
; 0000 02C4        base=10;
	RCALL SUBOPT_0x1A
; 0000 02C5        goto main;
	RJMP _0x31
; 0000 02C6      }
; 0000 02C7 
; 0000 02C8      case 30:
_0x41:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x5A
; 0000 02C9      //
; 0000 02CA      {
; 0000 02CB         temp=PINB;
	RCALL SUBOPT_0x1B
; 0000 02CC         temp=temp&128;
; 0000 02CD         if (temp==0)
	BRNE _0x5B
; 0000 02CE         //  
; 0000 02CF         {
; 0000 02D0          base=6; //
	LDI  R30,LOW(6)
	STD  Y+14,R30
; 0000 02D1          goto main;
	RJMP _0x31
; 0000 02D2         }
; 0000 02D3 
; 0000 02D4         if (cancel==1)
_0x5B:
	LDD  R26,Y+20
	CPI  R26,LOW(0x1)
	BRNE _0x5C
; 0000 02D5         //   
; 0000 02D6         {
; 0000 02D7           base=6; //
	LDI  R30,LOW(6)
	STD  Y+14,R30
; 0000 02D8           goto main;
	RJMP _0x31
; 0000 02D9         }
; 0000 02DA         pro=1;
_0x5C:
	LDI  R30,LOW(1)
	STD  Y+15,R30
; 0000 02DB         goto driver;
	RJMP _0x5D
; 0000 02DC 
; 0000 02DD      }
; 0000 02DE 
; 0000 02DF      case 1:
_0x5A:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x5F
; 0000 02E0      // rear
; 0000 02E1      {
; 0000 02E2 
; 0000 02E3       stl=lsy;
	RCALL SUBOPT_0x22
; 0000 02E4       str=rsy;
; 0000 02E5 
; 0000 02E6       drive=lvy;
	__PUTBSR 17,17
; 0000 02E7       drive=drive+rvy;
	LDD  R30,Y+26
	RCALL SUBOPT_0x23
; 0000 02E8 
; 0000 02E9 
; 0000 02EA 
; 0000 02EB       base=5;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x24
; 0000 02EC       pro=0;
; 0000 02ED       goto driver;
	RJMP _0x5D
; 0000 02EE      }
; 0000 02EF 
; 0000 02F0 
; 0000 02F1 
; 0000 02F2       case 5:
_0x5F:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x61
; 0000 02F3       {
; 0000 02F4        stl=lsx;
	RCALL SUBOPT_0x25
; 0000 02F5        str=rsx;
; 0000 02F6 
; 0000 02F7        drive=lvx;
	__PUTBSR 16,17
; 0000 02F8        drive=drive+rvx;
	LDD  R30,Y+23
	RCALL SUBOPT_0x23
; 0000 02F9 
; 0000 02FA         base=30;
	LDI  R30,LOW(30)
	RCALL SUBOPT_0x24
; 0000 02FB         pro=0;
; 0000 02FC        goto driver;
	RJMP _0x5D
; 0000 02FD 
; 0000 02FE       }
; 0000 02FF 
; 0000 0300 
; 0000 0301        case 6:
_0x61:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x63
; 0000 0302        //  rear
; 0000 0303       {
; 0000 0304        stl=lsx;
	RCALL SUBOPT_0x25
; 0000 0305        str=rsx;
; 0000 0306 
; 0000 0307        drive=160;
	LDI  R30,LOW(160)
	STD  Y+17,R30
; 0000 0308        if (lvx==160)
	CPI  R16,160
	BRNE _0x64
; 0000 0309        {
; 0000 030A         drive=144;
	LDI  R30,LOW(144)
	STD  Y+17,R30
; 0000 030B        }
; 0000 030C 
; 0000 030D         temp=10;
_0x64:
	LDI  R30,LOW(10)
	STD  Y+9,R30
; 0000 030E        if (rvx==10)
	LDD  R26,Y+23
	CPI  R26,LOW(0xA)
	BRNE _0x65
; 0000 030F        {
; 0000 0310         temp=9;
	LDI  R30,LOW(9)
	STD  Y+9,R30
; 0000 0311        }
; 0000 0312 
; 0000 0313        drive=drive+temp;
_0x65:
	LDD  R30,Y+9
	RCALL SUBOPT_0x23
; 0000 0314 
; 0000 0315 
; 0000 0316        base=7;
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x24
; 0000 0317        pro=0;
; 0000 0318        goto driver;
	RJMP _0x5D
; 0000 0319 
; 0000 031A       }
; 0000 031B             case 7:
_0x63:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x67
; 0000 031C 
; 0000 031D       {
; 0000 031E 
; 0000 031F 
; 0000 0320        stl=lsy;
	RCALL SUBOPT_0x22
; 0000 0321        str=rsy;
; 0000 0322 
; 0000 0323        drive=80;
	LDI  R30,LOW(80)
	STD  Y+17,R30
; 0000 0324        if (lvy==80)
	CPI  R17,80
	BRNE _0x68
; 0000 0325        {
; 0000 0326         drive=96;
	LDI  R30,LOW(96)
	STD  Y+17,R30
; 0000 0327        }
; 0000 0328 
; 0000 0329         temp=5;
_0x68:
	LDI  R30,LOW(5)
	STD  Y+9,R30
; 0000 032A        if (rvy==5)
	LDD  R26,Y+26
	CPI  R26,LOW(0x5)
	BRNE _0x69
; 0000 032B        {
; 0000 032C         temp=6;
	LDI  R30,LOW(6)
	STD  Y+9,R30
; 0000 032D        }
; 0000 032E 
; 0000 032F        drive=drive+temp;
_0x69:
	LDD  R30,Y+9
	RCALL SUBOPT_0x23
; 0000 0330 
; 0000 0331 
; 0000 0332 
; 0000 0333        base=8;
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x24
; 0000 0334        pro=0;
; 0000 0335        goto driver;
	RJMP _0x5D
; 0000 0336 
; 0000 0337       }
; 0000 0338       case  8:
_0x67:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x34
; 0000 0339       //  eeprom 
; 0000 033A       {
; 0000 033B           // 
; 0000 033C           #asm("cli");
	cli
; 0000 033D           read_adc(4);
	RCALL SUBOPT_0x7
; 0000 033E           if (ADCH<83)
	RCALL SUBOPT_0x8
	BRSH _0x6C
; 0000 033F            {
; 0000 0340             gis=1;
	RCALL SUBOPT_0x9
; 0000 0341             goto ini;
	RJMP _0x1D
; 0000 0342            }
; 0000 0343               if (gis==1)
_0x6C:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x6D
; 0000 0344         {
; 0000 0345          goto ini;
	RJMP _0x1D
; 0000 0346         }
; 0000 0347 
; 0000 0348           #asm("sei");
_0x6D:
	sei
; 0000 0349 
; 0000 034A        if (lvy!=elvy)
	RCALL SUBOPT_0xB
	RCALL __EEPROMRDB
	CP   R30,R17
	BREQ _0x6E
; 0000 034B        {
; 0000 034C         elvy=lvy;
	MOV  R30,R17
	RCALL SUBOPT_0xB
	RCALL __EEPROMWRB
; 0000 034D        }
; 0000 034E        if (lsy!=elsy)
_0x6E:
	RCALL SUBOPT_0xC
	RCALL __EEPROMRDW
	CP   R30,R18
	CPC  R31,R19
	BREQ _0x6F
; 0000 034F        {
; 0000 0350         elsy=lsy;
	MOVW R30,R18
	RCALL SUBOPT_0xC
	RCALL __EEPROMWRW
; 0000 0351        }
; 0000 0352        if (lvx!=elvx)
_0x6F:
	RCALL SUBOPT_0xE
	RCALL __EEPROMRDB
	CP   R30,R16
	BREQ _0x70
; 0000 0353        {
; 0000 0354         elvx=lvx;
	MOV  R30,R16
	RCALL SUBOPT_0xE
	RCALL __EEPROMWRB
; 0000 0355        }
; 0000 0356        if (lsx!=elsx)
_0x70:
	RCALL SUBOPT_0xF
	RCALL __EEPROMRDW
	CP   R30,R20
	CPC  R31,R21
	BREQ _0x71
; 0000 0357        {
; 0000 0358         elsx=lsx;
	MOVW R30,R20
	RCALL SUBOPT_0xF
	RCALL __EEPROMWRW
; 0000 0359        }
; 0000 035A        if (rvy!=ervy)
_0x71:
	RCALL SUBOPT_0x10
	RCALL __EEPROMRDB
	LDD  R26,Y+26
	CP   R30,R26
	BREQ _0x72
; 0000 035B        {
; 0000 035C         ervy=rvy;
	LDD  R30,Y+26
	RCALL SUBOPT_0x10
	RCALL __EEPROMWRB
; 0000 035D        }
; 0000 035E        if (rsy!=ersy)
_0x72:
	RCALL SUBOPT_0x11
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x17
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x73
; 0000 035F        {
; 0000 0360         ersy=rsy;
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x11
	RCALL __EEPROMWRW
; 0000 0361        }
; 0000 0362        if (rvx!=ervx)
_0x73:
	RCALL SUBOPT_0x12
	RCALL __EEPROMRDB
	LDD  R26,Y+23
	CP   R30,R26
	BREQ _0x74
; 0000 0363        {
; 0000 0364         ervx=rvx;
	LDD  R30,Y+23
	RCALL SUBOPT_0x12
	RCALL __EEPROMWRB
; 0000 0365        }
; 0000 0366        if (rsx!=ersx)
_0x74:
	RCALL SUBOPT_0x13
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x19
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x75
; 0000 0367        {
; 0000 0368         ersx=rsx;
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x13
	RCALL __EEPROMWRW
; 0000 0369        }
; 0000 036A        base=10;
_0x75:
	RCALL SUBOPT_0x1A
; 0000 036B        goto main;
	RJMP _0x31
; 0000 036C       }
; 0000 036D    }
_0x34:
; 0000 036E 
; 0000 036F  goto ini;
	RJMP _0x1D
; 0000 0370 
; 0000 0371  //     
; 0000 0372  // stl -    
; 0000 0373  // str -    
; 0000 0374  // drive - L , R 
; 0000 0375 
; 0000 0376  driver:   switch (pro)
_0x5D:
	LDD  R30,Y+15
	LDI  R31,0
; 0000 0377        {
; 0000 0378                 case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x79
; 0000 0379          {
; 0000 037A 
; 0000 037B                  templ=0;
	LDI  R30,LOW(0)
	STD  Y+7,R30
	STD  Y+7+1,R30
; 0000 037C 
; 0000 037D 
; 0000 037E                  lv1=0;
	RCALL SUBOPT_0x28
; 0000 037F                  lv0=0;
	RCALL SUBOPT_0x29
; 0000 0380                  rv1=0;
	RCALL SUBOPT_0x2A
; 0000 0381                  rv0=0;
	RCALL SUBOPT_0x2B
; 0000 0382 
; 0000 0383  scan:          PORTB=1;
_0x7A:
	RCALL SUBOPT_0x5
; 0000 0384 
; 0000 0385                 delay_us(10);
; 0000 0386                 temp=PINB;
; 0000 0387                 temp=temp&127;
	RCALL SUBOPT_0x1F
; 0000 0388                 if (temp==5)           //1+4
	CPI  R26,LOW(0x5)
	BRNE _0x7B
; 0000 0389                 {
; 0000 038A                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 038B                     delay_us(10);
; 0000 038C                     temp=PINB;
; 0000 038D                     temp=temp&127;
; 0000 038E                     if (temp==18)      //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x7C
; 0000 038F                     // 
; 0000 0390                     {
; 0000 0391                       port=80;
	LDI  R30,LOW(80)
	STD  Y+16,R30
; 0000 0392                       goto scan2;
	RJMP _0x7D
; 0000 0393 
; 0000 0394                     }
; 0000 0395 
; 0000 0396                      goto scanex;
_0x7C:
	RJMP _0x7E
; 0000 0397                 }
; 0000 0398 
; 0000 0399                 if (temp==17)            //1+16
_0x7B:
	LDD  R26,Y+9
	CPI  R26,LOW(0x11)
	BRNE _0x7F
; 0000 039A                 {
; 0000 039B                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 039C                     delay_us(10);
; 0000 039D                     temp=PINB;
; 0000 039E                      temp=temp&127;
; 0000 039F                     if (temp==6)        //2+4
	CPI  R26,LOW(0x6)
	BRNE _0x80
; 0000 03A0                     // 
; 0000 03A1                     {
; 0000 03A2                       port=96;
	LDI  R30,LOW(96)
	STD  Y+16,R30
; 0000 03A3                       goto scan2;
	RJMP _0x7D
; 0000 03A4 
; 0000 03A5                     }
; 0000 03A6 
; 0000 03A7 
; 0000 03A8                        if (temp==10)       //2+8
_0x80:
	LDD  R26,Y+9
	CPI  R26,LOW(0xA)
	BRNE _0x81
; 0000 03A9                     // 
; 0000 03AA                     {
; 0000 03AB                       port=160;
	LDI  R30,LOW(160)
	STD  Y+16,R30
; 0000 03AC                       goto scan2;
	RJMP _0x7D
; 0000 03AD 
; 0000 03AE                     }
; 0000 03AF                       if (temp==34)        //2+32
_0x81:
	LDD  R26,Y+9
	CPI  R26,LOW(0x22)
	BRNE _0x82
; 0000 03B0                     // 
; 0000 03B1                     {
; 0000 03B2                       port=6;
	LDI  R30,LOW(6)
	STD  Y+16,R30
; 0000 03B3                       goto scan2;
	RJMP _0x7D
; 0000 03B4 
; 0000 03B5                     }
; 0000 03B6 
; 0000 03B7                        if (temp==66)       //2+64
_0x82:
	LDD  R26,Y+9
	CPI  R26,LOW(0x42)
	BRNE _0x83
; 0000 03B8                     //  
; 0000 03B9                     {
; 0000 03BA                       port=10;
	LDI  R30,LOW(10)
	STD  Y+16,R30
; 0000 03BB                       goto scan2;
	RJMP _0x7D
; 0000 03BC 
; 0000 03BD                     }
; 0000 03BE                     goto scanex;
_0x83:
	RJMP _0x7E
; 0000 03BF 
; 0000 03C0 
; 0000 03C1                 }
; 0000 03C2 
; 0000 03C3                  if (temp==9)            //1+8
_0x7F:
	LDD  R26,Y+9
	CPI  R26,LOW(0x9)
	BRNE _0x84
; 0000 03C4                 {
; 0000 03C5                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 03C6                     delay_us(10);
; 0000 03C7                     temp=PINB;
; 0000 03C8                      temp=temp&127;
; 0000 03C9                     if (temp==18)         //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x85
; 0000 03CA                     // 
; 0000 03CB                     {
; 0000 03CC                       port=144;
	LDI  R30,LOW(144)
	STD  Y+16,R30
; 0000 03CD                       goto scan2;
	RJMP _0x7D
; 0000 03CE 
; 0000 03CF                     }
; 0000 03D0 
; 0000 03D1 
; 0000 03D2 
; 0000 03D3                     goto scanex;
_0x85:
	RJMP _0x7E
; 0000 03D4                 }
; 0000 03D5 
; 0000 03D6                  if (temp==33)
_0x84:
	LDD  R26,Y+9
	CPI  R26,LOW(0x21)
	BRNE _0x86
; 0000 03D7                 {
; 0000 03D8                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 03D9                     delay_us(10);
; 0000 03DA                     temp=PINB;
; 0000 03DB                      temp=temp&127;
; 0000 03DC                     if (temp==18)       //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x87
; 0000 03DD                     // 
; 0000 03DE                     {
; 0000 03DF                       port=5;
	LDI  R30,LOW(5)
	STD  Y+16,R30
; 0000 03E0                       goto scan2;
	RJMP _0x7D
; 0000 03E1 
; 0000 03E2                     }
; 0000 03E3 
; 0000 03E4 
; 0000 03E5 
; 0000 03E6                     goto scanex;
_0x87:
	RJMP _0x7E
; 0000 03E7                 }
; 0000 03E8                  if (temp==65)          //1+64
_0x86:
	LDD  R26,Y+9
	CPI  R26,LOW(0x41)
	BRNE _0x88
; 0000 03E9                 {
; 0000 03EA                     PORTB=2;
	RCALL SUBOPT_0x20
; 0000 03EB                     delay_us(10);
; 0000 03EC                     temp=PINB;
; 0000 03ED                      temp=temp&127;
; 0000 03EE 
; 0000 03EF                        if (temp==18)    //2+16
	CPI  R26,LOW(0x12)
	BRNE _0x89
; 0000 03F0                     //  
; 0000 03F1                     {
; 0000 03F2                       port=9;
	LDI  R30,LOW(9)
	STD  Y+16,R30
; 0000 03F3                       goto scan2;
	RJMP _0x7D
; 0000 03F4 
; 0000 03F5                     }
; 0000 03F6 
; 0000 03F7                 }
_0x89:
; 0000 03F8                 //--------------
; 0000 03F9 scanex:          port=0;
_0x88:
_0x7E:
	LDI  R30,LOW(0)
	STD  Y+16,R30
; 0000 03FA 
; 0000 03FB                  PORTD=0;
	RCALL SUBOPT_0x3
; 0000 03FC 
; 0000 03FD scan2:           temp=PINB;
_0x7D:
	RCALL SUBOPT_0x1B
; 0000 03FE                  temp=temp&128;
; 0000 03FF                  if (temp==0)
	BRNE _0x8A
; 0000 0400                    {
; 0000 0401                     base=6; //
	LDI  R30,LOW(6)
	STD  Y+14,R30
; 0000 0402                     goto main;
	RJMP _0x31
; 0000 0403                    }
; 0000 0404 
; 0000 0405                  if (port==80||port==96)
_0x8A:
	LDD  R26,Y+16
	CPI  R26,LOW(0x50)
	BREQ _0x8C
	CPI  R26,LOW(0x60)
	BRNE _0x8B
_0x8C:
; 0000 0406                 {
; 0000 0407                   goto start1;
	RJMP _0x8E
; 0000 0408                 }
; 0000 0409 
; 0000 040A                   if (port==160||port==144)
_0x8B:
	LDD  R26,Y+16
	CPI  R26,LOW(0xA0)
	BREQ _0x90
	CPI  R26,LOW(0x90)
	BRNE _0x8F
_0x90:
; 0000 040B                 {
; 0000 040C                  goto start3;
	RJMP _0x92
; 0000 040D                 }
; 0000 040E 
; 0000 040F                  if (port==5||port==6)
_0x8F:
	LDD  R26,Y+16
	CPI  R26,LOW(0x5)
	BREQ _0x94
	CPI  R26,LOW(0x6)
	BRNE _0x93
_0x94:
; 0000 0410                 {
; 0000 0411                   goto start2;
	RJMP _0x96
; 0000 0412                 }
; 0000 0413 
; 0000 0414                  if (port==9||port==10)
_0x93:
	LDD  R26,Y+16
	CPI  R26,LOW(0x9)
	BREQ _0x98
	CPI  R26,LOW(0xA)
	BRNE _0x97
_0x98:
; 0000 0415                 {
; 0000 0416                   goto start6;
	RJMP _0x9A
; 0000 0417                 }
; 0000 0418                 goto scan;
_0x97:
	RJMP _0x7A
; 0000 0419 
; 0000 041A 
; 0000 041B                  //    Y
; 0000 041C start1:          if (lsy==2000)
_0x8E:
	RCALL SUBOPT_0x2C
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x9B
; 0000 041D                 {
; 0000 041E                  if (lvy==80&&port==96)
	CPI  R17,80
	BRNE _0x9D
	LDD  R26,Y+16
	CPI  R26,LOW(0x60)
	BREQ _0x9E
_0x9D:
	RJMP _0x9C
_0x9E:
; 0000 041F                  {
; 0000 0420                   goto start11;
	RJMP _0x9F
; 0000 0421                  }
; 0000 0422                    if (lvy==96&&port==80)
_0x9C:
	CPI  R17,96
	BRNE _0xA1
	LDD  R26,Y+16
	CPI  R26,LOW(0x50)
	BREQ _0xA2
_0xA1:
	RJMP _0xA0
_0xA2:
; 0000 0423                  {
; 0000 0424                   goto start11;
	RJMP _0x9F
; 0000 0425                  }
; 0000 0426                  PORTD=0;
_0xA0:
	RCALL SUBOPT_0x3
; 0000 0427                  goto scan;
	RJMP _0x7A
; 0000 0428                 }
; 0000 0429 
; 0000 042A 
; 0000 042B start11:        PORTD=port;
_0x9B:
_0x9F:
	RCALL SUBOPT_0x21
; 0000 042C 
; 0000 042D                 starr=0;
	RCALL SUBOPT_0x2D
; 0000 042E                 starr=2;
; 0000 042F 
; 0000 0430  wait3:          if (starr==2)
_0xA3:
	RCALL SUBOPT_0x1
	BREQ _0xA3
; 0000 0431                  {
; 0000 0432                   goto wait3;
; 0000 0433                  }
; 0000 0434 
; 0000 0435 
; 0000 0436                  if (al>0)
	LDI  R30,LOW(0)
	CP   R30,R5
	BRSH _0xA5
; 0000 0437                  {
; 0000 0438 
; 0000 0439                    if (lv0>2)
	RCALL SUBOPT_0x2E
	BRLO _0xA6
; 0000 043A                    {
; 0000 043B 
; 0000 043C                     lv1=1;
	RCALL SUBOPT_0x2F
; 0000 043D                     lv0=0;
; 0000 043E                     lal=1;
	LDI  R30,LOW(1)
	STD  Y+2,R30
; 0000 043F                     goto next3;
	RJMP _0xA7
; 0000 0440                    }
; 0000 0441 
; 0000 0442                    lv0=0;
_0xA6:
	RCALL SUBOPT_0x29
; 0000 0443                    lv1++;
	RCALL SUBOPT_0x30
; 0000 0444                    goto next3;
	RJMP _0xA7
; 0000 0445                  }
; 0000 0446 
; 0000 0447                   lv1=0;
_0xA5:
	RCALL SUBOPT_0x28
; 0000 0448                   lv0++;
	RCALL SUBOPT_0x31
; 0000 0449 
; 0000 044A                  if (lal==1)
	BRNE _0xA8
; 0000 044B                  {
; 0000 044C                   if (lv0>2)
	RCALL SUBOPT_0x2E
	BRLO _0xA9
; 0000 044D                    {
; 0000 044E                     lal=0;
	RCALL SUBOPT_0x32
; 0000 044F                     lv0=0;
; 0000 0450 
; 0000 0451                     if(lvy==port)
	LDD  R30,Y+16
	CP   R30,R17
	BRNE _0xAA
; 0000 0452                     {
; 0000 0453                      lsy++;
	__ADDWRN 18,19,1
; 0000 0454                      if(lsy>2000)
	__CPWRN 18,19,2001
	BRLO _0xAB
; 0000 0455                      {
; 0000 0456                       lsy=2000;
	__GETWRN 18,19,2000
; 0000 0457 
; 0000 0458                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 0459                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 045A                       goto scan;
	RJMP _0x7A
; 0000 045B                      }
; 0000 045C                      goto next3;
_0xAB:
	RJMP _0xA7
; 0000 045D 
; 0000 045E                     }
; 0000 045F 
; 0000 0460                     if (lsy==0)
_0xAA:
	MOV  R0,R18
	OR   R0,R19
	BRNE _0xAC
; 0000 0461                     {
; 0000 0462                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 0463                       lvy=port;
	LDD  R17,Y+16
; 0000 0464                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 0465                       goto scan;
	RJMP _0x7A
; 0000 0466                     }
; 0000 0467                     lsy--;
_0xAC:
	__SUBWRN 18,19,1
; 0000 0468 
; 0000 0469 
; 0000 046A 
; 0000 046B                    }
; 0000 046C                  }
_0xA9:
; 0000 046D 
; 0000 046E next3:
_0xA8:
_0xA7:
; 0000 046F                  goto  scan;
	RJMP _0x7A
; 0000 0470 
; 0000 0471                   //    X
; 0000 0472  start3:                if (lsx==2000)
_0x92:
	RCALL SUBOPT_0x2C
	CP   R30,R20
	CPC  R31,R21
	BRNE _0xAD
; 0000 0473                 {
; 0000 0474                  if (lvx==160&&port==144)
	CPI  R16,160
	BRNE _0xAF
	LDD  R26,Y+16
	CPI  R26,LOW(0x90)
	BREQ _0xB0
_0xAF:
	RJMP _0xAE
_0xB0:
; 0000 0475                  {
; 0000 0476                   goto start31;
	RJMP _0xB1
; 0000 0477                  }
; 0000 0478                    if (lvx==144&&port==160)
_0xAE:
	CPI  R16,144
	BRNE _0xB3
	LDD  R26,Y+16
	CPI  R26,LOW(0xA0)
	BREQ _0xB4
_0xB3:
	RJMP _0xB2
_0xB4:
; 0000 0479                  {
; 0000 047A                   goto start31;
	RJMP _0xB1
; 0000 047B                  }
; 0000 047C                  goto scan;
_0xB2:
	RJMP _0x7A
; 0000 047D                 }
; 0000 047E 
; 0000 047F start31:         PORTD=port;
_0xAD:
_0xB1:
	RCALL SUBOPT_0x21
; 0000 0480 
; 0000 0481                  starr=0;
	RCALL SUBOPT_0x2D
; 0000 0482                  starr=2;
; 0000 0483 
; 0000 0484  wait5:          if (starr==2)
_0xB5:
	RCALL SUBOPT_0x1
	BREQ _0xB5
; 0000 0485                  {
; 0000 0486                   goto wait5;
; 0000 0487                  }
; 0000 0488 
; 0000 0489                  if (al>0)
	LDI  R30,LOW(0)
	CP   R30,R5
	BRSH _0xB7
; 0000 048A                  {
; 0000 048B 
; 0000 048C                    if (lv0>2)
	RCALL SUBOPT_0x2E
	BRLO _0xB8
; 0000 048D                    {
; 0000 048E 
; 0000 048F                     lv1=1;
	RCALL SUBOPT_0x2F
; 0000 0490                     lv0=0;
; 0000 0491                     lal=1;
	LDI  R30,LOW(1)
	STD  Y+2,R30
; 0000 0492                     goto next5;
	RJMP _0xB9
; 0000 0493                    }
; 0000 0494 
; 0000 0495                    lv0=0;
_0xB8:
	RCALL SUBOPT_0x29
; 0000 0496                    lv1++;
	RCALL SUBOPT_0x30
; 0000 0497                    goto next5;
	RJMP _0xB9
; 0000 0498                  }
; 0000 0499 
; 0000 049A                   lv1=0;
_0xB7:
	RCALL SUBOPT_0x28
; 0000 049B                   lv0++;
	RCALL SUBOPT_0x31
; 0000 049C 
; 0000 049D                  if (lal==1)
	BRNE _0xBA
; 0000 049E                  {
; 0000 049F                   if (lv0>2)
	RCALL SUBOPT_0x2E
	BRLO _0xBB
; 0000 04A0                    {
; 0000 04A1                     lal=0;
	RCALL SUBOPT_0x32
; 0000 04A2                     lv0=0;
; 0000 04A3 
; 0000 04A4                     if(lvx==port)
	LDD  R30,Y+16
	CP   R30,R16
	BRNE _0xBC
; 0000 04A5                     {
; 0000 04A6                      lsx++;
	__ADDWRN 20,21,1
; 0000 04A7                      if(lsx>2000)
	__CPWRN 20,21,2001
	BRLO _0xBD
; 0000 04A8                      {
; 0000 04A9                       lsx=2000;
	__GETWRN 20,21,2000
; 0000 04AA 
; 0000 04AB                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 04AC                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 04AD                       goto scan;
	RJMP _0x7A
; 0000 04AE                      }
; 0000 04AF                      goto next5;
_0xBD:
	RJMP _0xB9
; 0000 04B0 
; 0000 04B1                     }
; 0000 04B2 
; 0000 04B3                     if (lsx==0)
_0xBC:
	MOV  R0,R20
	OR   R0,R21
	BRNE _0xBE
; 0000 04B4                     {
; 0000 04B5                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 04B6                       lvx=port;
	LDD  R16,Y+16
; 0000 04B7                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 04B8                       goto scan;
	RJMP _0x7A
; 0000 04B9                     }
; 0000 04BA                     lsx--;
_0xBE:
	__SUBWRN 20,21,1
; 0000 04BB 
; 0000 04BC 
; 0000 04BD 
; 0000 04BE                    }
; 0000 04BF                  }
_0xBB:
; 0000 04C0 
; 0000 04C1 next5:
_0xBA:
_0xB9:
; 0000 04C2               goto  scan;
	RJMP _0x7A
; 0000 04C3 
; 0000 04C4        //      Y
; 0000 04C5 
; 0000 04C6 
; 0000 04C7 start2:          if (rsy==2000)
_0x96:
	RCALL SUBOPT_0x17
	CPI  R26,LOW(0x7D0)
	LDI  R30,HIGH(0x7D0)
	CPC  R27,R30
	BRNE _0xBF
; 0000 04C8                 {
; 0000 04C9                  if (rvy==6&&port==5)
	LDD  R26,Y+26
	CPI  R26,LOW(0x6)
	BRNE _0xC1
	LDD  R26,Y+16
	CPI  R26,LOW(0x5)
	BREQ _0xC2
_0xC1:
	RJMP _0xC0
_0xC2:
; 0000 04CA                  {
; 0000 04CB                   goto start21;
	RJMP _0xC3
; 0000 04CC                  }
; 0000 04CD                    if (rvy==5&&port==6)
_0xC0:
	LDD  R26,Y+26
	CPI  R26,LOW(0x5)
	BRNE _0xC5
	LDD  R26,Y+16
	CPI  R26,LOW(0x6)
	BREQ _0xC6
_0xC5:
	RJMP _0xC4
_0xC6:
; 0000 04CE                  {
; 0000 04CF                   goto start21;
	RJMP _0xC3
; 0000 04D0                  }
; 0000 04D1                  PORTD=0;
_0xC4:
	RCALL SUBOPT_0x3
; 0000 04D2                  goto scan;
	RJMP _0x7A
; 0000 04D3                 }
; 0000 04D4 
; 0000 04D5 start21:        PORTD=port;
_0xBF:
_0xC3:
	RCALL SUBOPT_0x21
; 0000 04D6 
; 0000 04D7                 starr=0;
	RCALL SUBOPT_0x2D
; 0000 04D8                 starr=2;
; 0000 04D9 
; 0000 04DA  wait4:          if (starr==2)
_0xC7:
	RCALL SUBOPT_0x1
	BREQ _0xC7
; 0000 04DB                  {
; 0000 04DC                   goto wait4;
; 0000 04DD                  }
; 0000 04DE 
; 0000 04DF                  if (ar>0)
	LDI  R30,LOW(0)
	CP   R30,R4
	BRSH _0xC9
; 0000 04E0                  {
; 0000 04E1                   if (rv0>2)
	RCALL SUBOPT_0x34
	BRLO _0xCA
; 0000 04E2                    {
; 0000 04E3                     rv1=1;
	RCALL SUBOPT_0x35
; 0000 04E4                     rv0=0;
; 0000 04E5                     lar=1;
	LDI  R30,LOW(1)
	STD  Y+1,R30
; 0000 04E6                     goto next4;
	RJMP _0xCB
; 0000 04E7                    }
; 0000 04E8 
; 0000 04E9                    rv0=0;
_0xCA:
	RCALL SUBOPT_0x2B
; 0000 04EA                    rv1++;
	RCALL SUBOPT_0x36
; 0000 04EB                    goto next4;
	RJMP _0xCB
; 0000 04EC                  }
; 0000 04ED 
; 0000 04EE                   rv1=0;
_0xC9:
	RCALL SUBOPT_0x2A
; 0000 04EF                   rv0++;
	RCALL SUBOPT_0x37
; 0000 04F0 
; 0000 04F1                  if (lar==1)
	BRNE _0xCC
; 0000 04F2                  {
; 0000 04F3                   if (rv0>2)
	RCALL SUBOPT_0x34
	BRLO _0xCD
; 0000 04F4                    {
; 0000 04F5                     lar=0;
	RCALL SUBOPT_0x38
; 0000 04F6                     rv0=0;
; 0000 04F7 
; 0000 04F8                     if(rvy==port)
	LDD  R30,Y+16
	LDD  R26,Y+26
	CP   R30,R26
	BRNE _0xCE
; 0000 04F9                     {
; 0000 04FA                      rsy++;
	RCALL SUBOPT_0x26
	ADIW R30,1
	RCALL SUBOPT_0x15
; 0000 04FB                      if(rsy>2000)
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	BRLO _0xCF
; 0000 04FC                      {
; 0000 04FD                       rsy=2000;
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x15
; 0000 04FE 
; 0000 04FF                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 0500                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 0501                       goto scan;
	RJMP _0x7A
; 0000 0502                      }
; 0000 0503                      goto next4;
_0xCF:
	RJMP _0xCB
; 0000 0504 
; 0000 0505                     }
; 0000 0506 
; 0000 0507                     if (rsy==0)
_0xCE:
	RCALL SUBOPT_0x26
	SBIW R30,0
	BRNE _0xD0
; 0000 0508                     {
; 0000 0509                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 050A                       rvy=port;
	LDD  R30,Y+16
	STD  Y+26,R30
; 0000 050B                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 050C                       goto scan;
	RJMP _0x7A
; 0000 050D                     }
; 0000 050E                     rsy--;
_0xD0:
	RCALL SUBOPT_0x26
	SBIW R30,1
	RCALL SUBOPT_0x15
; 0000 050F 
; 0000 0510 
; 0000 0511 
; 0000 0512                    }
; 0000 0513                  }
_0xCD:
; 0000 0514 
; 0000 0515 next4:
_0xCC:
_0xCB:
; 0000 0516                  goto  scan;
	RJMP _0x7A
; 0000 0517 
; 0000 0518                   //    X
; 0000 0519 start6:                if (rsx==2000)
_0x9A:
	RCALL SUBOPT_0x19
	CPI  R26,LOW(0x7D0)
	LDI  R30,HIGH(0x7D0)
	CPC  R27,R30
	BRNE _0xD1
; 0000 051A                 {
; 0000 051B                  if (rvx==10&&port==9)
	LDD  R26,Y+23
	CPI  R26,LOW(0xA)
	BRNE _0xD3
	LDD  R26,Y+16
	CPI  R26,LOW(0x9)
	BREQ _0xD4
_0xD3:
	RJMP _0xD2
_0xD4:
; 0000 051C                  {
; 0000 051D                   goto start61;
	RJMP _0xD5
; 0000 051E                  }
; 0000 051F                    if (rvx==9&&port==10)
_0xD2:
	LDD  R26,Y+23
	CPI  R26,LOW(0x9)
	BRNE _0xD7
	LDD  R26,Y+16
	CPI  R26,LOW(0xA)
	BREQ _0xD8
_0xD7:
	RJMP _0xD6
_0xD8:
; 0000 0520                  {
; 0000 0521                   goto start61;
	RJMP _0xD5
; 0000 0522                  }
; 0000 0523                  goto scan;
_0xD6:
	RJMP _0x7A
; 0000 0524                 }
; 0000 0525 
; 0000 0526 start61:        PORTD=port;
_0xD1:
_0xD5:
	RCALL SUBOPT_0x21
; 0000 0527 
; 0000 0528                 starr=0;
	RCALL SUBOPT_0x2D
; 0000 0529                 starr=2;
; 0000 052A 
; 0000 052B  wait6:          if (starr==2)
_0xD9:
	RCALL SUBOPT_0x1
	BREQ _0xD9
; 0000 052C                  {
; 0000 052D                   goto wait6;
; 0000 052E                  }
; 0000 052F 
; 0000 0530 
; 0000 0531                  if (ar>0)
	LDI  R30,LOW(0)
	CP   R30,R4
	BRSH _0xDB
; 0000 0532                  {
; 0000 0533                   if (rv0>2)
	RCALL SUBOPT_0x34
	BRLO _0xDC
; 0000 0534                    {
; 0000 0535 
; 0000 0536                     rv1=1;
	RCALL SUBOPT_0x35
; 0000 0537                     rv0=0;
; 0000 0538                     lar=1;
	LDI  R30,LOW(1)
	STD  Y+1,R30
; 0000 0539                     goto next6;
	RJMP _0xDD
; 0000 053A                    }
; 0000 053B 
; 0000 053C                    rv0=0;
_0xDC:
	RCALL SUBOPT_0x2B
; 0000 053D                    rv1++;
	RCALL SUBOPT_0x36
; 0000 053E                    goto next6;
	RJMP _0xDD
; 0000 053F                  }
; 0000 0540 
; 0000 0541                  rv1=0;
_0xDB:
	RCALL SUBOPT_0x2A
; 0000 0542                  rv0++;
	RCALL SUBOPT_0x37
; 0000 0543 
; 0000 0544                  if (lar==1)
	BRNE _0xDE
; 0000 0545                  {
; 0000 0546                   if (rv0>2)
	RCALL SUBOPT_0x34
	BRLO _0xDF
; 0000 0547                    {
; 0000 0548                     lar=0;
	RCALL SUBOPT_0x38
; 0000 0549                     rv0=0;
; 0000 054A 
; 0000 054B                     if(rvx==port)
	LDD  R30,Y+16
	LDD  R26,Y+23
	CP   R30,R26
	BRNE _0xE0
; 0000 054C                     {
; 0000 054D                      rsx++;
	RCALL SUBOPT_0x27
	ADIW R30,1
	RCALL SUBOPT_0x16
; 0000 054E                      if(rsx>2000)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x18
	BRLO _0xE1
; 0000 054F                      {
; 0000 0550                       rsx=2000;
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x16
; 0000 0551 
; 0000 0552                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 0553                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 0554                       goto scan;
	RJMP _0x7A
; 0000 0555                      }
; 0000 0556                      goto next6;
_0xE1:
	RJMP _0xDD
; 0000 0557 
; 0000 0558                     }
; 0000 0559 
; 0000 055A                     if (rsx==0)
_0xE0:
	RCALL SUBOPT_0x27
	SBIW R30,0
	BRNE _0xE2
; 0000 055B                     {
; 0000 055C                       PORTD=0;
	RCALL SUBOPT_0x3
; 0000 055D                       rvx=port;
	LDD  R30,Y+16
	STD  Y+23,R30
; 0000 055E                       delay_ms(500);
	RCALL SUBOPT_0x33
; 0000 055F                       goto scan;
	RJMP _0x7A
; 0000 0560                     }
; 0000 0561                     rsx--;
_0xE2:
	RCALL SUBOPT_0x27
	SBIW R30,1
	RCALL SUBOPT_0x16
; 0000 0562 
; 0000 0563 
; 0000 0564 
; 0000 0565                    }
; 0000 0566                  }
_0xDF:
; 0000 0567 
; 0000 0568 next6:
_0xDE:
_0xDD:
; 0000 0569                 goto  scan;
	RJMP _0x7A
; 0000 056A 
; 0000 056B          }
; 0000 056C                 case 0:
_0x79:
	SBIW R30,0
	BREQ PC+2
	RJMP _0x78
; 0000 056D 
; 0000 056E                 {
; 0000 056F                  lv1=0;
	RCALL SUBOPT_0x28
; 0000 0570                  lv0=0;
	RCALL SUBOPT_0x29
; 0000 0571                  rv1=0;
	RCALL SUBOPT_0x2A
; 0000 0572                  rv0=0;
	RCALL SUBOPT_0x2B
; 0000 0573 
; 0000 0574                 temp=3; //L=1 R=2 1+2=3
	LDI  R30,LOW(3)
	STD  Y+9,R30
; 0000 0575                 if (stl==0)
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xE5
; 0000 0576 
; 0000 0577                 {
; 0000 0578                  temp=temp&2;
	LDD  R30,Y+9
	ANDI R30,LOW(0x2)
	STD  Y+9,R30
; 0000 0579                 }
; 0000 057A                  if (str==0)
_0xE5:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BRNE _0xE6
; 0000 057B 
; 0000 057C                 {
; 0000 057D                  temp=temp&1;
	LDD  R30,Y+9
	ANDI R30,LOW(0x1)
	STD  Y+9,R30
; 0000 057E                 }
; 0000 057F 
; 0000 0580                 if (temp==0)
_0xE6:
	LDD  R30,Y+9
	CPI  R30,0
	BRNE _0xE7
; 0000 0581                 {
; 0000 0582                   //    0
; 0000 0583 
; 0000 0584                  goto main;
	RJMP _0x31
; 0000 0585                 }
; 0000 0586                 port=drive;
_0xE7:
	LDD  R30,Y+17
	STD  Y+16,R30
; 0000 0587 
; 0000 0588                 //
; 0000 0589                 if (stl==0)
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xE8
; 0000 058A                 {
; 0000 058B                   // 
; 0000 058C                   port=port&0x0f;
	LDD  R30,Y+16
	ANDI R30,LOW(0xF)
	STD  Y+16,R30
; 0000 058D                 }
; 0000 058E                  if (str==0)
_0xE8:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BRNE _0xE9
; 0000 058F                 {
; 0000 0590                    // 
; 0000 0591                  port=port&0xf0;
	LDD  R30,Y+16
	ANDI R30,LOW(0xF0)
	STD  Y+16,R30
; 0000 0592 
; 0000 0593                 }
; 0000 0594                 PORTD=port;
_0xE9:
	RCALL SUBOPT_0x21
; 0000 0595 
; 0000 0596 
; 0000 0597                 starr=0;
	RCALL SUBOPT_0x2D
; 0000 0598                 starr=2;
; 0000 0599 
; 0000 059A 
; 0000 059B  wait:          if (starr==2)
_0xEA:
	RCALL SUBOPT_0x1
	BREQ _0xEA
; 0000 059C                  {
; 0000 059D                   goto wait;
; 0000 059E                  }
; 0000 059F 
; 0000 05A0    //--              //   
; 0000 05A1                  //    
; 0000 05A2 
; 0000 05A3                  PORTB=1;
	RCALL SUBOPT_0x5
; 0000 05A4 
; 0000 05A5                 delay_us(10);
; 0000 05A6                 temp=PINB;
; 0000 05A7                 temp=temp&127;
	RCALL SUBOPT_0x1F
; 0000 05A8                 if (temp==5||temp==33)           //1+4      1+32
	CPI  R26,LOW(0x5)
	BREQ _0xED
	LDD  R26,Y+9
	CPI  R26,LOW(0x21)
	BRNE _0xEC
_0xED:
; 0000 05A9                  {
; 0000 05AA                     PORTB=2;
	LDI  R30,LOW(2)
	OUT  0x18,R30
; 0000 05AB                     delay_us(5);
	__DELAY_USB 13
; 0000 05AC                     temp=PINB;
	IN   R30,0x16
	STD  Y+9,R30
; 0000 05AD                     temp=temp&127;
	RCALL SUBOPT_0x1F
; 0000 05AE                     if (temp==18)              //2+16
	CPI  R26,LOW(0x12)
	BRNE _0xEF
; 0000 05AF                     //    
; 0000 05B0                     {
; 0000 05B1                      cancel=1;
	LDI  R30,LOW(1)
	STD  Y+20,R30
; 0000 05B2                     }
; 0000 05B3 
; 0000 05B4                  }
_0xEF:
; 0000 05B5 
; 0000 05B6 
; 0000 05B7 
; 0000 05B8 
; 0000 05B9 
; 0000 05BA                     //  
; 0000 05BB                     //    
; 0000 05BC                       temp=PINB;
_0xEC:
	RCALL SUBOPT_0x1B
; 0000 05BD                       temp=temp&128;
; 0000 05BE                       if (temp==0)
	BRNE _0xF0
; 0000 05BF                       //  
; 0000 05C0                        {
; 0000 05C1                          cancel=1;
	LDI  R30,LOW(1)
	STD  Y+20,R30
; 0000 05C2                        }
; 0000 05C3 
; 0000 05C4 
; 0000 05C5                  if (al>0)
_0xF0:
	LDI  R30,LOW(0)
	CP   R30,R5
	BRSH _0xF1
; 0000 05C6                  {
; 0000 05C7                   if (lv0>2)
	RCALL SUBOPT_0x2E
	BRLO _0xF2
; 0000 05C8                    {
; 0000 05C9                     lv1=1;
	RCALL SUBOPT_0x2F
; 0000 05CA                     lv0=0;
; 0000 05CB                     lal=1;
	LDI  R30,LOW(1)
	STD  Y+2,R30
; 0000 05CC                     goto next1;
	RJMP _0xF3
; 0000 05CD                    }
; 0000 05CE 
; 0000 05CF                    lv0=0;
_0xF2:
	RCALL SUBOPT_0x29
; 0000 05D0                    lv1++;
	RCALL SUBOPT_0x30
; 0000 05D1                    goto next1;
	RJMP _0xF3
; 0000 05D2                  }
; 0000 05D3 
; 0000 05D4                   lv1=0;
_0xF1:
	RCALL SUBOPT_0x28
; 0000 05D5                   lv0++;
	RCALL SUBOPT_0x31
; 0000 05D6 
; 0000 05D7 
; 0000 05D8                  if (lal==1)
	BRNE _0xF4
; 0000 05D9                  {
; 0000 05DA                   if (lv0>2)
	RCALL SUBOPT_0x2E
	BRLO _0xF5
; 0000 05DB                    {
; 0000 05DC                     lal=0;
	RCALL SUBOPT_0x32
; 0000 05DD                     lv0=0;
; 0000 05DE                     stl--;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
; 0000 05DF                    }
; 0000 05E0                  }
_0xF5:
; 0000 05E1 
; 0000 05E2 
; 0000 05E3 next1:
_0xF4:
_0xF3:
; 0000 05E4                  if (ar>0)
	LDI  R30,LOW(0)
	CP   R30,R4
	BRSH _0xF6
; 0000 05E5                  {
; 0000 05E6                   if (rv0>2)
	RCALL SUBOPT_0x34
	BRLO _0xF7
; 0000 05E7                    {
; 0000 05E8                     rv1=1;
	RCALL SUBOPT_0x35
; 0000 05E9                     rv0=0;
; 0000 05EA                     lar=1;
	LDI  R30,LOW(1)
	STD  Y+1,R30
; 0000 05EB                     goto next2;
	RJMP _0xF8
; 0000 05EC                    }
; 0000 05ED 
; 0000 05EE                    rv0=0;
_0xF7:
	RCALL SUBOPT_0x2B
; 0000 05EF                    rv1++;
	RCALL SUBOPT_0x36
; 0000 05F0                    goto next2;
	RJMP _0xF8
; 0000 05F1                  }
; 0000 05F2 
; 0000 05F3                   rv1=0;
_0xF6:
	RCALL SUBOPT_0x2A
; 0000 05F4                   rv0++;
	RCALL SUBOPT_0x37
; 0000 05F5 
; 0000 05F6 
; 0000 05F7 
; 0000 05F8                  if (lar==1)
	BRNE _0xF9
; 0000 05F9                  {
; 0000 05FA                   if (rv0>2)
	RCALL SUBOPT_0x34
	BRLO _0xFA
; 0000 05FB                    {
; 0000 05FC                     lar=0;
	RCALL SUBOPT_0x38
; 0000 05FD                     rv0=0;
; 0000 05FE                     str--;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 05FF                    }
; 0000 0600                  }
_0xFA:
; 0000 0601 
; 0000 0602 
; 0000 0603 next2:           if (stl==0||lv1>254||lv0>254)
_0xF9:
_0xF8:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,0
	BREQ _0xFC
	LDD  R26,Y+6
	CPI  R26,LOW(0xFF)
	BRSH _0xFC
	LDD  R26,Y+5
	CPI  R26,LOW(0xFF)
	BRLO _0xFB
_0xFC:
; 0000 0604                   {
; 0000 0605 
; 0000 0606                   port=port&0x0F;
	LDD  R30,Y+16
	ANDI R30,LOW(0xF)
	STD  Y+16,R30
; 0000 0607                   }
; 0000 0608 
; 0000 0609 
; 0000 060A                   if (str==0||rv1>254||rv0>254)
_0xFB:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BREQ _0xFF
	LDD  R26,Y+4
	CPI  R26,LOW(0xFF)
	BRSH _0xFF
	LDD  R26,Y+3
	CPI  R26,LOW(0xFF)
	BRLO _0xFE
_0xFF:
; 0000 060B                   {
; 0000 060C 
; 0000 060D                   port=port&0xF0;
	LDD  R30,Y+16
	ANDI R30,LOW(0xF0)
	STD  Y+16,R30
; 0000 060E                   }
; 0000 060F 
; 0000 0610 
; 0000 0611                   PORTD=port;
_0xFE:
	RCALL SUBOPT_0x21
; 0000 0612                   if (port==0)
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x101
; 0000 0613                   {
; 0000 0614 
; 0000 0615                    delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x4
; 0000 0616 
; 0000 0617                    //  
; 0000 0618                    goto main;
	RJMP _0x31
; 0000 0619                   }
; 0000 061A 
; 0000 061B                   starr=2;
_0x101:
	LDI  R30,LOW(2)
	MOV  R7,R30
; 0000 061C                   goto wait;
	RJMP _0xEA
; 0000 061D 
; 0000 061E                  goto main;
; 0000 061F                 }
; 0000 0620        }
_0x78:
; 0000 0621 
; 0000 0622  goto ini;
	RJMP _0x1D
; 0000 0623   };
; 0000 0624 }
_0x102:
	RJMP _0x102
;         /*
;
;
;
;           PORTB=1;
;                      
;
;              4          32
;               16         16
;              16         16
;             8          64
;
;           PORTB=2;
;                      
;
;             16          16
;              4           32
;             8           64
;            16          16
;
;          //
;
;       PORTD=80;  //
;       PORTD=96;  //
;       PORTD=160;  //
;       PORTD=144; //
;
;      //
;
;       PORTD=5;  //
;       PORTD=6;  //
;       PORTD=10; //
;       PORTD=9; //
;
;
;           */
;
;
;                 /*
;
;         +
;         +
;
;
;
;        */
;
;

	.DSEG
_tmheat:
	.BYTE 0x4

	.ESEG
_elvy:
	.DB  0x0
_elsy:
	.DW  0x0
_elvx:
	.DB  0x0
_elsx:
	.DW  0x0
_ervy:
	.DB  0x0
_ersy:
	.DW  0x0
_ervx:
	.DB  0x0
_ersx:
	.DW  0x0
_pause:
	.DB  0x0

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0x0:
	__DELAY_USB 27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(2)
	CP   R30,R7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	RJMP _read_adc

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	OUT  0x12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(1)
	OUT  0x18,R30
	RCALL SUBOPT_0x0
	IN   R30,0x16
	STD  Y+9,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(2)
	OUT  0x18,R30
	RCALL SUBOPT_0x0
	IN   R30,0x16
	STD  Y+9,R30
	LDD  R26,Y+9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	IN   R30,0x5
	CPI  R30,LOW(0x53)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	LDI  R26,LOW(_elvy)
	LDI  R27,HIGH(_elvy)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDI  R26,LOW(_elsy)
	LDI  R27,HIGH(_elsy)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(_elvx)
	LDI  R27,HIGH(_elvx)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R26,LOW(_elsx)
	LDI  R27,HIGH(_elsx)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(_ervy)
	LDI  R27,HIGH(_ervy)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(_ersy)
	LDI  R27,HIGH(_ersy)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R26,LOW(_ervx)
	LDI  R27,HIGH(_ervx)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R26,LOW(_ersx)
	LDI  R27,HIGH(_ersx)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x14:
	STD  Y+9,R30
	LDD  R26,Y+9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	STD  Y+24,R30
	STD  Y+24+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	STD  Y+21,R30
	STD  Y+21+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	CPI  R26,LOW(0x7D1)
	LDI  R30,HIGH(0x7D1)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(10)
	STD  Y+14,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x1B:
	IN   R30,0x16
	STD  Y+9,R30
	ANDI R30,LOW(0x80)
	STD  Y+9,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	STD  Y+18,R30
	STD  Y+18+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	SBIW R30,1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x1F:
	LDD  R30,Y+9
	ANDI R30,0x7F
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:43 WORDS
SUBOPT_0x20:
	LDI  R30,LOW(2)
	OUT  0x18,R30
	RCALL SUBOPT_0x0
	IN   R30,0x16
	STD  Y+9,R30
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x21:
	LDD  R30,Y+16
	OUT  0x12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x22:
	__PUTWSR 18,19,12
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	LDD  R26,Y+17
	ADD  R30,R26
	STD  Y+17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x24:
	STD  Y+14,R30
	LDI  R30,LOW(0)
	STD  Y+15,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x25:
	__PUTWSR 20,21,12
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	LDI  R30,LOW(0)
	STD  Y+6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(0)
	STD  Y+5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(0)
	STD  Y+4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(0)
	STD  Y+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2D:
	CLR  R7
	LDI  R30,LOW(2)
	MOV  R7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDD  R26,Y+5
	CPI  R26,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2F:
	LDI  R30,LOW(1)
	STD  Y+6,R30
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x30:
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x31:
	LDD  R30,Y+5
	SUBI R30,-LOW(1)
	STD  Y+5,R30
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x32:
	LDI  R30,LOW(0)
	STD  Y+2,R30
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x33:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	LDD  R26,Y+3
	CPI  R26,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x35:
	LDI  R30,LOW(1)
	STD  Y+4,R30
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x36:
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x37:
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x38:
	LDI  R30,LOW(0)
	STD  Y+1,R30
	RJMP SUBOPT_0x2B


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
